package com.ruoyi.cai.mq;

import org.springframework.amqp.core.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;


@Configuration
public class CommonDelayMqConfig {

    public static final String EXCHANGE_NAME = "commonDelayExchange";
    public static final String QUEUE_NAME = "commonDelayQueue";
    public static final String ROUTING_KEY = "commonDelayRouting";

    @Bean
    public CustomExchange commonDelayedExchange() {
        HashMap<String,Object> args = new HashMap<>();
        args.put("x-delayed-type", "direct");
        return new CustomExchange(EXCHANGE_NAME,
                "x-delayed-message", // 消息类型
                true, // 是否持久化
                false,// 是否自动删除
                args);
    }

    @Bean
    public Queue commonDelayedQueue() {
        return QueueBuilder.durable(QUEUE_NAME)
                .withArgument("x-delayed-type", "direct")
                .build();
    }

    @Bean
    public Binding commonDelayedBinding(Queue commonDelayedQueue,CustomExchange commonDelayedExchange) {
        return BindingBuilder.bind(commonDelayedQueue()).to(commonDelayedExchange()).with(ROUTING_KEY).noargs();
    }

}
